﻿using System;
using System.Windows;
using System.Windows.Media.Imaging;
using System.IO;

namespace LocalJoost.ImageCutting
{
    public class ImageCutter
    {
        private string _fileName;
        public ImageCutter(string fileName)
        {
            _fileName = fileName;
        }

        public void Cut(int TileSize, int TilesX, int TilesY)
        {
            var img = new BitmapImage();
            img.BeginInit();
            img.UriSource = new Uri(_fileName);
            img.CacheOption = BitmapCacheOption.OnLoad;
            img.EndInit();

            var fInfo = new FileInfo(_fileName);

            for (int x = 0; x < TilesX; x++)
            {
                for (int y = 0; y < TilesY; y++)
                {
                    var subImg = new CroppedBitmap(img,
                                      new Int32Rect(x * TileSize,
                                                    y * TileSize,
                                                    TileSize, TileSize));
                    SaveImage(subImg, fInfo.Extension, 
                        string.Format( "{0}_{1}{2}", x, y, fInfo.Extension));

                }
            }
        }

        //Method for saving the image data as image in to spec
        private void SaveImage(BitmapSource image, string extension, string filePath)
        {
            var encoder = ImageUtilities.GetEncoderFromExtension(extension);
            using (var fs = new FileStream(filePath, FileMode.Create, FileAccess.Write))
            {
                encoder.Frames.Add(BitmapFrame.Create(image));
                encoder.Save(fs);
                fs.Flush();
                fs.Close();
            }
        }
    }
}
