﻿using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace LocalJoost.ImageCutting
{
    /// <summary>
    /// Class with Image utilities - duh
    /// </summary>
    public static class ImageUtilities
    {
        public static BitmapEncoder GetEncoderFromMimeType(string mimeType)
        {
            switch (mimeType.ToLower())
            {
                case "image/jpg":
                case "image/jpeg": 
                  return new JpegBitmapEncoder();
                case "image/gif": 
                    return new GifBitmapEncoder();
                case "image/png":
                    return new PngBitmapEncoder();
                case "image/tif":
                case "image/tiff":
                    return new TiffBitmapEncoder();
                case "image/bmp": 
                    return new BmpBitmapEncoder();
            }
            return null;
        }

        public static BitmapEncoder GetEncoderFromExtension(string extension)
        {
            return GetEncoderFromMimeType( extension.Replace(".", "image/"));
        }
    }
}

